<!doctype html>
<html>

	<head>
		<meta charset="utf-8">
		<title>A Space BullShit</title>
		<meta name="viewport" content="width=device-width, user-scalable=no,
		shrink-to-fit=no, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0" />

		<meta http-equiv="Content-Security-Policy" content="default-src *; style-src * 'unsafe-inline'; script-src * 'unsafe-inline' 'unsafe-eval'; img-src *; connect-src *">
		<!--<script src= "./assets/libs/pixi.min.js"></script>-->
		<script src="https://cdnjs.cloudflare.com/ajax/libs/pixi.js/4.5.1/pixi.min.js"></script>
		<style>* {padding: 0; margin: 0}</style>
	</head>
	
	<body>
		
		<script>
			
		  //pixi sınıfları örneklenerek kısaltılır.
		  // pythonda rndint = random.randint gibi
			let Application = PIXI.Application, //pixi uygulamasının anasınıfı
					loader = PIXI.loader, // resimleri yüklemek için
					resources = PIXI.loader.resources, //resimleri yüklemek için
					Sprite = PIXI.Sprite, //yüklenen resimleri kullanmak için
					Container = PIXI.Container; // resimleri gruplandırmak için

			let win = window,
    		doc = document,
    		docE = doc.documentElement,
    		docBody = docE.getElementsByTagName('body')[0],
    		docWidth = win.innerWidth || docE.clientWidth || docBody.clientWidth,
    		docHeight = win.innerHeight|| docE.clientHeight|| docBody.clientHeight;
    		
    		console.log(docWidth, docHeight);
					
			//ana app sınıfı yaratılır.
			let app = new Application(
			{ 
    		width: docWidth, 
    		height: docHeight,                       
    		antialias: true, 
    		transparent: false, 
    		resolution: 1
  		});
  		
  		if(!localStorage.getItem("levelState"))
  		{
  			let levelState = {fightKostok : false,
  												userItemList : []};
  		
  			localStorage.setItem("levelState", JSON.stringify(levelState));
  		}
  											
  		

  		//html'in body tag'ine çocuk olarak atılır. bu sayede app'imiz html sayfasında görülür.
  		document.body.appendChild(app.view);
  		

  		
  		
  		//loader sınıfının add fonksiyonu ile yüklenecek resimler konularından
  		//liste halinde alınır.
  		loader
  			.add(["./assets/backgrounds/black.png",
  						"./assets/planets/SunRed.png",
  						"./assets/planets/planet5.png",
  						"./assets/planets/planet10.png",
  						"./assets/planets/planet3.png",
  						"./assets/planets/planet12.png",
  						"./assets/ships/playerShip3_blue.png",
  						"./assets/ships/playerShip1_orange.png",
  						"./assets/Meteors/meteorBrown_tiny2.png",
  						"./assets/Meteors/meteorGrey_tiny2.png"])
  			.load(setup);//setup fonksiyonu içine yüklenir.
  		
  		//değişkenler yaratılır.
  		let sun, planet1, planet2, planet3, planet4, playerShip, kostokShip, meteorContainer;
  		
  		let a = 90, b = 180, c = 270, d = 300, e = 320; //gezegenleri çembersel şekilde döndürmek için gereken fonksiyondaki değişkenler

  		let meteorList = [];
  		let gezegenList = [];
  		let meteorLocs = [];
  		
  		
  		
  		function setup()
  		{
  			
  			//arkaplan resmi yüklenir.
  			let bg = new Sprite(resources["./assets/backgrounds/black.png"].texture);
  			
  			bg.position.set(0, 0) //x ve y konumuna 0 atanır.
  			bg.width = docWidth;
  			bg.height = docHeight;
  			
  			bg.buttonMode = true;
  			bg.interactive = true;
  			
  			bg
  		      .on('mousedown', touchStart)
              .on('mouseup', touchEnd)
              .on('mousemove', touchMove)
              .on('touchstart', touchStart)
              .on('touchmove', touchMove)
              .on('touchend', touchEnd); 
  			
  			app.stage.addChild(bg); //app'imize atılır. bu sayede görünür olur.
  			
  			sun = new Sprite(resources["./assets/planets/SunRed.png"].texture);
  			
  			sun.anchor.set(0.5); //güneşin referans noktası sol-üst köşeden ortasına çekilir.
  			
  			sun.width = docWidth / 5;
  			sun.height = docHeight / 5;
  			
  			sun.x = docWidth / 2;
  			sun.y = docHeight / 2;
  			
  			app.stage.addChild(sun);
  			
  			planet1 = new Sprite(resources["./assets/planets/planet5.png"].texture);
  			
  			planet1.anchor.set(0.5);
  			
  			planet1.width = docWidth / 20;
  			planet1.height = docHeight / 20;
  			
				planet1.x = sun.x + ((docWidth / 18 + sun.height / 2) * Math.cos(a));
    		planet1.y = sun.y + (docWidth / 18 * Math.sin(a));
  			
  			gezegenList.push(planet1);
  			app.stage.addChild(planet1);

  			planet2 = new Sprite(resources["./assets/planets/planet10.png"].texture);
  			
  			planet2.anchor.set(0.5);
  			
  			planet2.width = docWidth / 12;
  			planet2.height = docHeight / 12;
  			
				planet2.x = sun.x + ((docWidth / 10 + sun.height / 2) * Math.cos(b));
    		planet2.y = sun.y + (docWidth / 10 * Math.sin(b));
  			
  			gezegenList.push(planet2);
  			app.stage.addChild(planet2);
  			
  			planet3 = new Sprite(resources["./assets/planets/planet3.png"].texture);
  			
  			planet3.anchor.set(0.5);
  			
  			planet3.width = docWidth / 12;
  			planet3.height = docHeight / 12;
  			
				planet3.x = sun.x + ((docWidth / 7 + sun.height / 2) * Math.cos(c));
    		planet3.y = sun.y + (docWidth / 7 * Math.sin(c));
  			
  			gezegenList.push(planet3);
  			app.stage.addChild(planet3);

  			planet4 = new Sprite(resources["./assets/planets/planet12.png"].texture);
  			
  			planet4.anchor.set(0.5);
  			
  			planet4.width = docWidth / 15;
  			planet4.height = docHeight / 15;
  			
				planet4.x = sun.x + ((docWidth / 6 + sun.height / 2) * Math.cos(d));
    		planet4.y = sun.y + (docWidth / 6 * Math.sin(d));
    		
  			gezegenList.push(planet4);
  			app.stage.addChild(planet4);
  			
  			
  			//meteorContainer = new Container({x:260, y:0});
  			
  			
  			
  			/*
  			for (let i = 0; i < 6; i++)
  			{
  				if(i % 2 === 0)
  				{
  					let brownMeteor = new Sprite(resources["./assets/Meteors/meteorBrown_tiny2.png"].texture);
  					brownMeteor.x =  randomInt(sun.x - 200 - sun.height / 2, sun.x - 230 - sun.height / 2);
  					brownMeteor.y = randomInt(app.stage.height / 2, app.stage.height / 2 + 30 );
  					meteorContainer.addChild(brownMeteor);
  				
  				}
  				else
  				{
  					let greyMeteor = new Sprite(resources["./assets/Meteors/meteorGrey_tiny2.png"].texture);
  						greyMeteor.x =  randomInt(sun.x - 200 - sun.height / 2, sun.x - 230 - sun.height / 2);
  						greyMeteor.y = randomInt(app.stage.height / 2, app.stage.height / 2 + 30);
  						meteorContainer.addChild(greyMeteor);
  				
  				
  				}
  			
  			}*/
  			
  			let xCentre = docWidth / 2;
  			let yCentre = docHeight / 2;
  			
  			let xCoord = docWidth / 3;
  			let yCoord = (docHeight / 5) * 2;
  			
  			//eliptik şekilde meteor attık.
  			for (let i = 0 * Math.PI; i < 2 * Math.PI; i += 1.0)
  			{
  				meteorLocs.push(i);
  				if(randomInt(0,10) % 2 === 0)
  				{
  					let brownMeteor = new Sprite(resources["./assets/Meteors/meteorBrown_tiny2.png"].texture);
  					brownMeteor.x = xCentre - (xCoord * Math.cos(i));
  					brownMeteor.y = yCentre - (yCoord * Math.sin(i));
  					meteorList.push(brownMeteor); //çarpışma kontrolü için meteorları listeye attık.
  					app.stage.addChild(brownMeteor);
  				
  				}
  				else
  				{
  					let greyMeteor = new Sprite(resources["./assets/Meteors/meteorGrey_tiny2.png"].texture);
  					greyMeteor.x = xCentre - (xCoord * Math.cos(i));
  					greyMeteor.y = yCentre - (yCoord * Math.sin(i));
  					meteorList.push(greyMeteor);
  					app.stage.addChild(greyMeteor);
  				}
  			}
  			
  			
  			playerShip = new Sprite(resources["./assets/ships/playerShip3_blue.png"].texture);
  			
  			playerShip.anchor.set(0.5);
  			
  			playerShip.width = docWidth / 40;
  			playerShip.height = docHeight / 20;
  			
  			playerShip.x = 50;
  			playerShip.y = docHeight - 50;
  			
  			playerShip.vx = 0; //playerımızın x ve y eksenindeki hızları belirlenir.
  			playerShip.vy = 0;
  			
  			app.stage.addChild(playerShip);
  			
  			kostokShip = new Sprite(resources["./assets/ships/playerShip1_orange.png"].texture);
  			
  			kostokShip.anchor.set(0.5);
  			
  			kostokShip.width = docWidth / 40;
  			kostokShip.height = docHeight / 20;
  			
  			kostokShip.x = docWidth - 50;
  			kostokShip.y = docHeight - 50;
  			
  			kostokShip.vx = 0;
  			kostokShip.vy = 0;
  			
  			app.stage.addChild(kostokShip);
  			
  			
  			let left = keyboard(37), //sol tuşun ascii kodu ile keyboar sınıfı örneklenir.
            up = keyboard(38),   //yukarı tuşun ascii kodu ile keyboar sınıfı örneklenir.
            right = keyboard(39),//sağ tuşun ascii kodu ile keyboar sınıfı örneklenir.
            down = keyboard(40); //alt tuşun ascii kodu ile keyboar sınıfı örneklenir.
            
			//sol tuşa basıldığında çalışacak method. 
        left.press = () => {
        
            //oyuncunun hızı atanır ve yön tayin edilir.
            playerShip.rotation = 3*(Math.PI/2); // resim 270 derece döndürülür. bu sayede burnu sola bakar.
            playerShip.vx = -0.2;
            playerShip.vy = 0;
            
        };
  
        //sol tuş bırakıldığında çalışacak method.
        left.release = () => {
            //sol tuş bırakıldığında sağ tuşa basılı değil ise
            //gemi yatayda hareket etmez
            if (!right.isDown && playerShip.vy === 0) {
                playerShip.vx = 0;
            }
        };

        //üst
        up.press = () => {
        		
        		playerShip.rotation = Math.PI * 0;
            playerShip.vy = -0.2;
            playerShip.vx = 0;
            
        };
        up.release = () => {
        
            if (!down.isDown && playerShip.vx === 0) {
                playerShip.vy = 0;
            }
        };

        //sağ
        right.press = () => {
        		
        		playerShip.rotation = Math.PI / 2;
						playerShip.vx = 0.2;
            playerShip.vy = 0;
        };
        right.release = () => {
        
            if (!left.isDown && playerShip.vy === 0) {
                playerShip.vx = 0;
            }
        };

        //aşağı
        down.press = () => {
        
        		playerShip.rotation = Math.PI;
            playerShip.vy = 0.2;
            playerShip.vx = 0;
            
        };
        down.release = () => {
        
            if (!up.isDown && playerShip.vx === 0) {
                playerShip.vy = 0;
            }
        };
  			
  			app.ticker.add(delta => gameLoop(delta)); // gameloop fonksiyonu saniyede 60 kere çağırılır.
  			//ana oyun döngüsü.
  			
  			intervals();
  			console.log(docWidth, docHeight);

  		}
  		
  		function  intervals()
  		{
  			/*
  			setInterval(function (){
  				a = (a + Math.PI / 360) % (Math.PI * 2);
  				rotate(planet1, a, 40 + sun.height / 2);
  				}, 100);
  				
  			setInterval(function () {
  				b = (b + Math.PI / 360) % (Math.PI * 2);
  				rotate(planet2, b, 60 + sun.height / 2);
  				}, 300);
  				
  			setInterval(function () {
  				c = (c + Math.PI / 360) % (Math.PI * 2);
  				rotate(planet3, c, 100 + sun.height / 2);
  				}, 500);
  			setInterval(function () {
  				d = (d + Math.PI / 360) % (Math.PI * 2);
  				rotate(planet4, d, 120 + sun.height / 2);
  				}, 700);*/
  				
  			
  			//interval 2 argüman olarak belirtilen süre
  			//aralıklarıyla fonksiyonu tekrar çağırır.
  			//oyun döngüsüne sabit saniyede 60 kere çağırdığı
  			//için yazmadık.Her gezegen farklı hızla dönüyor.
  			setInterval(function (){
  				a = (a + Math.PI / 360) % (Math.PI * 2);
  				rotateElliptic(planet1, sun.x, sun.y,  docWidth / 18 + sun.height / 2, docWidth / 18, a);
  				}, 100); //--->2. argüman 100 milisaniye 1000 milisaniye 1 saniye
  				
  			setInterval(function () {
  				b = (b + Math.PI / 360) % (Math.PI * 2);
  				rotateElliptic(planet2, sun.x, sun.y, docWidth / 10 + sun.height / 2, docWidth / 10, b);
  				}, 300);
  				
  			setInterval(function () {
  				c = (c + Math.PI / 360) % (Math.PI * 2);
  				rotateElliptic(planet3, sun.x, sun.y, docWidth / 7 + sun.height / 2, docWidth / 7, c);
  				}, 500);
  				
  			setInterval(function () {
  				d = (d + Math.PI / 360) % (Math.PI * 2);
  				rotateElliptic(planet4, sun.x, sun.y, docWidth / 6 + sun.height / 2, docWidth / 6, d);
  				}, 700);
  				
  			for (let i = 0; i < meteorList.length; i++)
  			{
  				setInterval(function() {
  					meteorLocs[i] = (meteorLocs[i] + Math.PI / 360) % (Math.PI * 2);
  					rotateElliptic(meteorList[i], sun.x, sun.y, docWidth / 3, 2 * (docHeight / 5), meteorLocs[i]);
  				}, 1000);
  			}
  				
  		}
  		
  		function gameLoop(delta)
  		{
  			
  			controlGameState();
  			
  			//saniyede 60 kere a değeri güncellenir ve bu değer ile
  			//gezegenler çembersel hareket yapar.
  			//1. argüman gezegenin referansı 2. argüman a değeri 3. argüman izleyeceği yarıçap değeridir.
  			//a = (a + Math.PI / 360) % (Math.PI * 2);
				//rotate(planet1, a, 40 + sun.height / 2);
				//rotate(planet2, a, 60 + sun.height / 2);
				//rotate(planet3, a, 100 + sun.height / 2);
				//rotate(planet4, a, 120 + sun.height / 2);
				
				//intervals();
				
				
				//haritanın içinde kalması için gereken fonksiyon
				// 9,9 geminin x ve y büyüklüklerinin yarısı
				//gemi tilesinin anchorunu 0.5 yapıp referans noktasını sol üstten ortaya çektik.
				if (contain(playerShip, {x : playerShip.width / 2, y : playerShip.height / 2, 
						width: docWidth, height : docHeight}) === undefined)
				{
					playerShip.x += playerShip.vx; //oyuncu yatayda hareket ettikçe konumu değişir.
					playerShip.y += playerShip.vy; // oyuncu düşeyde hareket ettikçe konumu değişir.
				}
				
				//kostokun hareket fonksiyonu çağırılıyor.
				rotateKostok();
				kostokShip.x += kostokShip.vx;
				kostokShip.y += kostokShip.vy;
				
				//çarpışma tespit edilirse true döndürür.
				if(hitTestRectangle(kostokShip, playerShip) &&  
				   JSON.parse(localStorage.getItem("levelState")).fightKostok === false)
				{
					console.log("yarrağımı ye fener");
					location.replace("./sections/fightKostok/main.html");
				}
				
				meteorList.concat(gezegenList).forEach(function(element){
					if(hitTestRectangle(kostokShip, element))
					{
						kostokShip.visible = false;
						
						if (kostokShip.y === 9 * (app.stage.height / 10))
						{
							kostokShip.x += 20;
							
						}
						
						else if (kostokShip.y === (app.stage.height / 10))
						{
							kostokShip.x -= 20;
						
						}
						setTimeout(function(){kostokShip.visible = true;}, 1000);
						
					}
					
					});
				
				meteorList.forEach(function(element){
					if(hitTestRectangle(playerShip, element))
					{
						//buraya harabe bölümü gelecek.
						//sectiondan uygun dosyaya gidilecek.
						console.log("yarrak var yen mi?");
					}
				});
				
			}
  		
  		function controlGameState()
  		{
  			if(JSON.parse(localStorage.getItem("levelState")).fightKostok)
  			{
  				app.stage.removeChild(kostokShip);
  			
  			
  			}
  		
  		
  		}
  		function randomInt(min, max)
  		{
  			return Math.floor(Math.random() * (max - min + 1)) + min;
			}
			
			function rotate(planet, a, r) 
			{
  			
  			planet.x = sun.x + r * Math.cos(a);
  			planet.y = sun.y + r * Math.sin(a); 
			}
			
			function calculateDistance(planet, planet1)
			{
			
				let xAxis = planet.x - planet1.x;
				let yAxis = planet.y - planet1.y;
				
				return pisagor(xAxis, yAxis);
			
			}
			
			function pisagor(x, y)
			{
			
				return Math.sqrt(Math.pow(x,2) + Math.pow(y,2));
			
			}

    function keyboard(keyCode)
     {
    
        let key = {};
        key.code = keyCode;
        key.isDown = false;
        key.isUp = true;
        key.press = undefined;
        key.release = undefined;
        //tuşa basıldığında tetiklecek olay
        key.downHandler = event => {
            if (event.keyCode === key.code) {
                if (key.isUp && key.press) key.press();
                key.isDown = true;
                key.isUp = false;
            }
        event.preventDefault();
    };

        //tuş bırakıldığında tetiklecek olay.
        key.upHandler = event => {
            if (event.keyCode === key.code) {
                if (key.isDown && key.release) key.release();
                key.isDown = false;
                key.isUp = true;
        }
        event.preventDefault();
    };

        //olay takip edici. klavye işlemlerini takip eder.
        //belirtilen fonksiyonu çağırır.(2. argüman)
        window.addEventListener(
            "keydown", key.downHandler.bind(key), false
        );
        window.addEventListener(
            "keyup", key.upHandler.bind(key), false
        );
        return key;
        
    }
    
    function contain(sprite, container)
     {

  		let collision = undefined;

  		//sol
  		if (sprite.x < container.x) {
    		sprite.x = container.x;
    		collision = "left";
  		}

  		//üst
  		if (sprite.y < container.y) {
    		sprite.y = container.y;
    		collision = "top";
  		}

  		//sağ
  		if (sprite.x + sprite.width / 2 > container.width) {
    		sprite.x = container.width - sprite.width;
    		collision = "right";
  		}

  		//alt
  		if (sprite.y + sprite.height / 2 > container.height) {
    		sprite.y = container.height - sprite.height;
    		collision = "bottom";
  		}

  		//Return the `collision` value
  		return collision;
		}
		
		function rotateKostok()
		{
			if (Math.abs(kostokShip.y) === Math.abs(docHeight - 50) && 
					Math.abs(kostokShip.x) === Math.abs(docWidth - 50))
			{
				kostokShip.rotation = Math.PI * 0;
				kostokShip.vy = -0.5;
				kostokShip.vx = 0;
			
			}
			
			else if (Math.abs(kostokShip.y) === Math.abs(50) && 
							 Math.abs(kostokShip.x) === Math.abs(docWidth - 50))
			{
				kostokShip.rotation = 3*(Math.PI/2);
				kostokShip.vy = 0;
				kostokShip.vx = -0.5;
			
			}
			
			else if (Math.abs(kostokShip.y) === Math.abs(50) && 
							 Math.abs(kostokShip.x) === 50)
			{
				kostokShip.rotation = Math.PI;
				kostokShip.vy = 0.5;
				kostokShip.vx = 0;
			
			}
			
			else if (Math.abs(kostokShip.y) === Math.abs(docHeight - 50) && 
							Math.abs(kostokShip.x) ===  50)
			{
				kostokShip.rotation = Math.PI / 2;
				kostokShip.vy = 0;
				kostokShip.vx = 0.5;
			
			}
		
		}
		
		function hitTestRectangle(r1, r2) {

  		
  		let hit, combinedHalfWidths, combinedHalfHeights, vx, vy;

  		
  		hit = false;

  		//çarpışma kontrolü yapılacak 2 nesnenin
  		//yatayda ve düşeyde orta noktaları bulunur.
  		r1.centerX = r1.x + r1.width / 2;
  		r1.centerY = r1.y + r1.height / 2;
  		r2.centerX = r2.x + r2.width / 2;
  		r2.centerY = r2.y + r2.height / 2;

  		
  		//yarı uzunlukları bulunur.
  		r1.halfWidth = r1.width / 2;
  		r1.halfHeight = r1.height / 2;
  		r2.halfWidth = r2.width / 2;
  		r2.halfHeight = r2.height / 2;

  		
  		//x ve y eksenleri arasındaki mesafe bulunur.
  		vx = r1.centerX - r2.centerX;
  		vy = r1.centerY - r2.centerY;

  		
  		//yarı uzunlukları toplamı bulunur.
  		combinedHalfWidths = r1.halfWidth + r2.halfWidth;
  		combinedHalfHeights = r1.halfHeight + r2.halfHeight;

  		//yatay merkezleri arasındaki mesafe
  		//yatay uzunlukları toplamının mutlak değerinden küçükse
  		if (Math.abs(vx) < combinedHalfWidths) {

    		//düşey merkezleri arasındaki mesafe
    		//düşey uzunluklarının toplamının mutlak değerinden küçükse
    		if (Math.abs(vy) < combinedHalfHeights) {

      		//çarpışma vardır.
      		hit = true;
    		} else {

      		//yoksa yoktur.
      		hit = false;
    		}
  		} else {

    	
    		hit = false;
  		}

  		return hit;
		};
		
		function rotateElliptic(object, xCentre, yCentre, a, b, i)
		{
			object.x = xCentre + (a * Math.cos(i));
    	    object.y = yCentre + (b * Math.sin(i));
		
		}
		
		function touchStart(event){
			this.data = event.data;
			this.flag = true;
			this.startX = this.data.getLocalPosition(this.parent).y;
			this.startY = this.data.getLocalPosition(this.parent).x;
		}
		
		function touchEnd(){
			this.flag = false;
			this.data = null;
		}
		
		function touchMove(event){
			if(event.target !== null && this.flag && this.startX >= y / 2)
			{
				this.curX = this.data.getLocalPosition(this.parent).y;
				this.curY = this.data.getLocalPosition(this.parent).x;
				if (this.curX - this.startX > 0 && Math.abs(this.curX-this.startX)>Math.abs(this.curY-this.startY)) {
					playerShip.vx = 0.2;
					playerShip.vy = 0;
					playerShip.rotation = Math.PI / 2;
					console.log(playerShip.vx);
					console.log(playerShip.vy);
				}
				if(this.curX - this.startX < 0 && Math.abs(this.curX-this.startX)>Math.abs(this.curY-this.startY)){
					playerShip.vx = -0.2;
					playerShip.vy = 0;
					playerShip.rotation = 3*(Math.PI/2);
					console.log(playerShip.vx);
					console.log(playerShip.vy);					
				}
				if(this.curY - this.startY > 0 && Math.abs(this.curX-this.startX)<Math.abs(this.curY-this.startY)){
					playerShip.vx = 0;
					playerShip.vy = 0.2;
					playerShip.rotation = Math.PI;
					console.log(playerShip.vx);
					console.log(playerShip.vy);							
				}
				if(this.curY - this.startY < 0 && Math.abs(this.curX-this.startX)<Math.abs(this.curY-this.startY)){
					playerShip.vx = 0;
					playerShip.vy = -0.2;
					playerShip.rotation = Math.PI * 0;
					console.log(playerShip.vx);
					console.log(playerShip.vy);							
				}
			}
		}
		
		
		</script>
		
	</body>		
	
</html>
